(**********************************************
 **              Unit DemoForm               **
 ** ---------------------------------------- **
 **             Demo Exe-Button              **
 ** ---------------------------------------- **
 **                                          **
 **  Delphi 1.01 / MAINFORM.PAS /  H.Drner **
 **  created        : 10.02.1996             **
 **  last Update    : 01.03.1996             **
 **                                          **
 **********************************************)

unit Demoform;

{=============================================}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  {$ifdef win32}
    Exebtn32,
  {$else}
    ExeBtn,
  {$endif}
  StdCtrls,ExtCtrls;

type
  TFormDemo = class(TForm)
    Panel1: TPanel;
    ExeBtn6: TExeBtn;
    ExeBtn1: TExeBtn;
    ExeBtn2: TExeBtn;
    ExeBtn3: TExeBtn;
    Panel2: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    ExeBtn4: TExeBtn;
    Panel3: TPanel;
    Label3: TLabel;
    ExeBtn5: TExeBtn;
    Timer1: TTimer;
    CheckBox2: TCheckBox;
    CheckBox1: TCheckBox;
    LabelInfo: TLabel;
    Panel4: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Label4: TLabel;
    Panel5: TPanel;
    Label6: TLabel;
    ScrollBar1: TScrollBar;
    Label8: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ExeBtn6Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure ExeBtn5Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure ShowHint(Sender: TObject);
    procedure CheckWinDir(ExeBtnStr:string);
  end;

var
  FormDemo: TFormDemo;

{=============================================}

implementation

{$R *.DFM}

{----------------------------------------------
 shows the hint in a label }

procedure TFormDemo.ShowHint(Sender: TObject);
begin
  LabelInfo.Caption := ' '+Application.Hint;
end;

{----------------------------------------------
 Get windows-directory }

procedure TFormDemo.CheckWinDir(ExeBtnStr:string);
var WinDirSz:array[0..128] of char;
    WinDirStr,s:string;
    p:byte;
    Component:TComponent;
begin
  Component:=FindComponent(ExeBtnStr);
  GetWindowsDirectory(WinDirSz,sizeof(WinDirSz));
  WinDirStr:=StrPas(WinDirSz);
  {ExeFile}
  p:=Pos('C:\WINDOWS',UpperCase((Component as TExeBtn).ExeFile));
  if p<>0 then begin
    s:=(Component as TExeBtn).ExeFile;
    Delete(s,p,10);
    s:=WinDirStr+s;
    (Component as TExeBtn).ExeFile:=s;
  end;
  {ExeIconFile}
  p:=Pos('C:\WINDOWS',UpperCase((Component as TExeBtn).ExeIconFile));
  if p<>0 then begin
    s:=(Component as TExeBtn).ExeIconFile;
    Delete(s,p,10);
    s:=WinDirStr+s;
    (Component as TExeBtn).ExeIconFile:=s;
  end;
end;

{----------------------------------------------}

procedure TFormDemo.FormCreate(Sender: TObject);
var i:byte;
begin
  { Hints in a label }
  Top:=0;
  Left:=Screen.Width-Width;
  Application.OnHint:=ShowHint;
  LabelInfo.Caption:='';

  for i:=1 to 6
  do CheckWinDir('ExeBtn'+IntToStr(i));

  ExeBtn6.ExeIconFile:=ExtractFilePath(Application.ExeName)+'\exebtn.bmp'
end;

{----------------------------------------------}

procedure TFormDemo.ExeBtn6Click(Sender: TObject);
begin
  case ExeBtn6.Language of
    german : ExeBtn6.ExeParams:=ExtractFilePath(Application.ExeName)+
                                'exeger.wri';
    english: ExeBtn6.ExeParams:=ExtractFilePath(Application.ExeName)+
                                'exeeng.wri';
  end;
end;

{----------------------------------------------}

procedure TFormDemo.Timer1Timer(Sender: TObject);
begin
  if ExeBtn5.ExeIconIndex<100
  then ExeBtn5.ExeIconIndex:=ExeBtn5.ExeIconIndex+1
  else ExeBtn5.ExeIconIndex:=0;
end;

{----------------------------------------------}

procedure TFormDemo.CheckBox1Click(Sender: TObject);
var i:byte;
    Component:TComponent;
begin
  for i:=1 to 6 do begin
    Component:=FindComponent('ExeBtn'+IntToStr(i));
    (Component as TExeBtn).ExeOneInstance:=CheckBox1.Checked;
  end;
end;

{----------------------------------------------}

procedure TFormDemo.CheckBox2Click(Sender: TObject);
var i:byte;
    Component:TComponent;
begin
  for i:=1 to 6 do begin
    Component:=FindComponent('ExeBtn'+IntToStr(i));
    (Component as TExeBtn).ExecAndWait:=CheckBox2.Checked;
  end;
end;

procedure TFormDemo.RadioButton1Click(Sender: TObject);
var i:byte;
    Component:TComponent;
begin
  for i:=1 to 6 do begin
    Component:=FindComponent('ExeBtn'+IntToStr(i));
    if RadioButton1.Checked then
    (Component as TExeBtn).ExeShowCmd:=scNormal;
    if RadioButton2.Checked then
    (Component as TExeBtn).ExeShowCmd:=scMaximize;
    if RadioButton3.Checked then
    (Component as TExeBtn).ExeShowCmd:=scMinimize;
    if RadioButton4.Checked then
    (Component as TExeBtn).ExeShowCmd:=scNA;
  end;
end;

procedure TFormDemo.ExeBtn5Click(Sender: TObject);
begin
  ShowMessage('Icons from the file moreicons.dll on a button. Great!');
end;

procedure TFormDemo.ScrollBar1Change(Sender: TObject);
var i:byte;
    Component:TComponent;
begin
  for i:=1 to 6 do begin
    Component:=FindComponent('ExeBtn'+IntToStr(i));
    (Component as TExeBtn).ExeIconZoom:=Scrollbar1.Position/100;
  end;
end;

end.
